/*
 *  Copyright (C), 2001-2015, ɶʿͨ
 *  All right reserved
 *
 *  ļ:   sm_pki.h
 *  ժ    Ҫ:   ԿʩӦϵ 豸Ӧýӿڹ淶
 *
 *  ǰ汾:   V1.0.1406.1710
 *      :   
 *  :   2014-06-17
 *
 *  ʷ汾:
 *  1. 2014-6-17, , 
 */

#ifndef __SW_SM_PKIAPI_INTERFACE_H_2008060411__
#define __SW_SM_PKIAPI_INTERFACE_H_2008060411__

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
//#include "normal.h"
#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/wait.h>


#define PKI_API_VERSION              "1, 2, 211115" " build " __DATE__

/* ///////////////////////////////////////////////////////////////////////// */
/*  	*/
/* ///////////////////////////////////////////////////////////////////////// */

/*  1.Գ㷨ʶ   */
#define SGD_SM1_ECB             0x00000101  /* SM1㷨ECBģʽ           */
#define SGD_SM1_CBC             0x00000102  /* SM1㷨CBCģʽ           */
#define SGD_SM1_CFB             0x00000104  /* SM1㷨CFBģʽ           */
#define SGD_SM1_OFB             0x00000108  /* SM1㷨OFBģʽ           */
#define SGD_SM1_MAC             0x00000110  /* SM1㷨MACģʽ           */
#define SGD_SM4_ECB             0x00000401  /* SM4㷨ECBģʽ           */
#define SGD_SM4_CBC             0x00000402  /* SM4㷨CBCģʽ           */
#define SGD_SM4_CFB             0x00000404  /* SM4㷨CFBģʽ           */
#define SGD_SM4_OFB             0x00000408  /* SM4㷨OFBģʽ           */
#define SGD_SM4_MAC             0x00000410  /* SM4㷨MACģʽ           */
/*                              0x000010000x80000000  ΪԳ㷨Ԥ  */

/*  2.ǶԳ㷨ʶ  */
#define SGD_RSA                 0x00010000  /* RSA㷨			            */
#define SGD_SM2				    0x00020100	/* Բ㷨             */
#define SGD_SM2_1               0x00020200  /* Բǩ㷨             */
#define SGD_SM2_2               0x00020400  /* ԲԿЭ         */
#define SGD_SM2_3               0x00020800  /* Բ߼㷨             */
/*                              0x000400000x80000000 ΪǶԳ㷨Ԥ */

/*  3.Ӵ㷨ʶ    */
#define SGD_SM3                 0x00000001  /* SM3Ӵ㷨                  */
#define SGD_SHA1                0x00000002  /* SHA1Ӵ㷨                 */
#define SGD_SHA256              0x00000004  /* SHA256Ӵ㷨               */
/*                              0x000000080x000000FF  ΪӴ㷨Ԥ  */

/*  4.ǩ㷨ʶ    */
#define SGD_SM3_RSA			    0x00010001  /* SM3㷨RSA㷨ǩ   */
#define SGD_SHA1_RSA		    0x00010002  /* SHA_1㷨RSA㷨ǩ */
#define SGD_SHA256_RSA		    0x00010004  /* SHA_256㷨RSA㷨ǩ*/
#define SGD_SM3_SM2			    0x00020201  /* SM3㷨SM2㷨ǩ    */
/*							    0x000400000x800000FFΪǩ㷨Ԥ */

/*  4.RSAԿṹ */
#define RSAref_MAX_BITS         2048
#define RSAref_MAX_LEN          ((RSAref_MAX_BITS + 7) / 8)
#define RSAref_MAX_PBITS        ((RSAref_MAX_BITS + 1) / 2)
#define RSAref_MAX_PLEN         ((RSAref_MAX_PBITS + 7)/ 8)

/*  5.ECCԿṹ */
#define ECCref_BITS_256		    256
#define ECCref_MAX_BITS		    512 
#define ECCref_MAX_LEN		    ((ECCref_MAX_BITS+7) / 8)

/*  6.ûݱʶID*/
#define SD_ID_LEN				16

/*  7.㳣 */
#define ECCENC_MIN_LEN		    1   /*ECCС*/
#define ECCENC_MAX_LEN		    128 /*ECC󳤶*/
#define ECCSIG_MAX_LEN			64  /*ECCǩݳ*/

#define SGD_SM2_1_KEY		0			/*key for sign or verify*/
#define SGD_SM2_3_KEY		1			/*key for enc or dec*/

/*  8.붨    */
#define SDR_OK                  0x0             /* ɹ                 */
#define SDR_BASE	            0x01000000	    /* ֵ             */
#define SDR_UNKNOWERR	        SDR_BASE+0x01	/* δ֪                 */
#define SDR_NOTSUPPORT	        SDR_BASE+0x02	/* ֵ֧Ľӿڵ         */
#define SDR_COMMFAIL	        SDR_BASE+0x03	/* 豸ͨʧ           */
#define SDR_HARDFAIL	        SDR_BASE+0x04	/* ģӦ           */
#define SDR_OPENDEVICE	        SDR_BASE+0x05	/* 豸ʧ             */
#define SDR_OPENSESSION	        SDR_BASE+0x06	/* Ựʧ             */
#define SDR_PARDENY	            SDR_BASE+0x07	/* ˽ԿʹȨ           */
#define SDR_KEYNOTEXIST	        SDR_BASE+0x08	/* ڵԿ         */
#define SDR_ALGNOTSUPPORT	    SDR_BASE+0x09	/* ֵ֧㷨         */
#define SDR_ALGMODNOTSUPPORT	SDR_BASE+0x0A	/* ֵ֧㷨ģʽ     */
#define SDR_PKOPERR	            SDR_BASE+0x0B	/* Կʧ             */
#define SDR_SKOPERR	            SDR_BASE+0x0C	/* ˽Կʧ             */
#define SDR_SIGNERR	            SDR_BASE+0x0D	/* ǩʧ             */
#define SDR_VERIFYERR	        SDR_BASE+0x0E	/* ֤ǩʧ             */
#define SDR_SYMOPERR	        SDR_BASE+0x0F	/* Գ㷨ʧ         */
#define SDR_STEPERR	            SDR_BASE+0x10	/* ಽ㲽         */
#define SDR_FILESIZEERR	        SDR_BASE+0x11	/* ļȳ         */
#define SDR_FILENOEXIST	        SDR_BASE+0x12	/* ָļ         */
#define SDR_FILEOFSERR	        SDR_BASE+0x13	/* ļʼλô         */
#define SDR_KEYTYPEERR	        SDR_BASE+0x14	/* Կʹ             */
#define SDR_KEYERR	            SDR_BASE+0x15	/* Կ                 */
#define SDR_ENCDATAERR          SDR_BASE+0x16   /* ECCݴ          */
#define SDR_RANDERR             SDR_BASE+0x17   /* ʧ           */
#define SDR_PRDRERR             SDR_BASE+0x18   /* ˽ԿʹȨ޻ȡʧ     */
#define SDR_MACERR              SDR_BASE+0x19   /* MACʧ              */
#define SDR_FILEEXISTS          SDR_BASE+0x1A   /* ָļѴ           */
#define SDR_FILEWERR            SDR_BASE+0x1B   /* ļдʧ             */
#define SDR_NOBUFFER            SDR_BASE+0x1C   /* 洢ռ䲻             */
#define SDR_INARGERR            SDR_BASE+0x1D   /*              */
#define SDR_OUTARDERR           SDR_BASE+0x1E   /*              */
#define SDR_HASHINITERR         SDR_BASE+0x24   /* HASHʼʧ           */
#define SDR_HASHUPDATAERR		SDR_BASE+0x25   /* HASHUPDATEʧ       */
#define SDR_HASHFINALERR		SDR_BASE+0x26   /* HASHFINALʧ        */
#define SDR_AUTHERR				SDR_BASE+0x27   /* Ա֤ʧ           */
#define SDR_IMPORTSYMKEYERR		SDR_BASE+0x28   /* ԳԿʧ         */
#define SDR_IMPORTASYMKEYERR	SDR_BASE+0x29   /* ǶԳԿʧ       */
#define SDR_VERIFYKEYERR		SDR_BASE+0x30   /* ԿУʧ       		*/
/*                              0x0000001F0x00FFFFFF  Ԥ                */

/* ///////////////////////////////////////////////////////////////////////// */
/*  ṹ	*/
/* ///////////////////////////////////////////////////////////////////////// */
/*  1. DeviceInfo_st            豸Ϣ
 *
 *  Ա                ˵
 *  IssuerName          40B     豸
 *  DeviceName          16B     豸ͺ
 *  DeviceSerial        16B     豸ţڣ8ַκţ3ַˮţ5ַ
 *  DeviceVersion       4B      豸ڲİ汾
 *  StandardVersion     4B      豸ֵ֧Ľӿڹ淶汾
 *  AsymAlgAbility      8B      ǰ4ֽڱʾֵ֧㷨,ʾΪǶԳ㷨ʶλĽ
                                4ֽڱʾ㷨ģʾΪֵ֧ģλĽ
 *  SymAlgAbility       4B      ֵ֧ĶԳ㷨ʾΪԳ㷨ʶλ
 *  HashAlgAbility      4B      ֵ֧Ӵ㷨ʾΪӴ㷨ʶλ
 *  BufferSize          4B      ֵ֧ļ洢ռ䣨λֽڣ
 */


typedef struct DeviceInfo_st{
    unsigned char IssuerName[40];
    unsigned char DeviceName[16];
    unsigned char DeviceSerial[16];
    unsigned int  DeviceVersion;
    unsigned int  StandardVersion;
    unsigned int  AsymAlgAbility[2];
    unsigned int  SymAlgAbility;
    unsigned int  HashAlgAbility;
    unsigned int  BufferSize;
}DEVICEINFO, *PDEVICEINFO;

/*  2. RSArefPublicKey_st       RSAԿݽṹ
 *
 *  Ա                ˵
 *  bits                4B      Կģ
 *  m                   256B    ģN
 *  e                   256B    Կָ
 */
typedef struct RSArefPublicKey_st
{
    unsigned int  bits;
    unsigned char m[RSAref_MAX_LEN];
    unsigned char e[RSAref_MAX_LEN];
} RSArefPublicKey, *PRSArefPublicKey;

/*  3. RSArefPrivateKey_st      RSA˽Կݽṹ
 *
 *  Ա                ˵
 *  bits                4B      Կģ
 *  m                   256B    ģN
 *  e                   256B    Կָ
 *  d                   256B    ˽Կָ
 *  prime               128*2B  pq
 *  pexp                128*2B  Dp Dq
 *  coef                128     ϵi
 */
typedef struct RSArefPrivateKey_st
{
    unsigned int  bits;
    unsigned char m[RSAref_MAX_LEN];
    unsigned char e[RSAref_MAX_LEN];
    unsigned char d[RSAref_MAX_LEN];
    unsigned char prime[2][RSAref_MAX_PLEN];
    unsigned char pexp[2][RSAref_MAX_PLEN];
    unsigned char coef[RSAref_MAX_PLEN];
} RSArefPrivateKey, *PRSArefPrivateKey;

/*  4. ECCrefPublicKey_st       ECCԿݽṹ
 *
 *  Ա                ˵
 *  bits                4B      Կλ
 *  x                   32B     Կx
 *  y                   32B     Կy
 */
typedef struct ECCrefPublicKey_st
{
	unsigned int  bits;
	unsigned char x[ECCref_MAX_LEN]; 
	unsigned char y[ECCref_MAX_LEN]; 
} ECCrefPublicKey;

/*  5. ECCrefPrivateKey_st      ECC˽Կݽṹ
 *
 *  Ա                ˵
 *  bits                4B      Կλ
 *  K                   32B     ˽Կ
 */
typedef struct ECCrefPrivateKey_st
{
    unsigned int  bits;
    unsigned char K[ECCref_MAX_LEN];
} ECCrefPrivateKey;

/*  6. ECCCipher_st             ECCݽṹ
 *
 *  Ա                ˵
 *  x                   32B     X
 *  y                   32B     Y
 *  M                   32B     ĵӴֵ
 *  L                   4B      ݳ
 *  C                   L       
 */

typedef struct ECCCipher_st
{
	unsigned char x[ECCref_MAX_LEN]; 
	unsigned char y[ECCref_MAX_LEN]; 
    unsigned char M[32];
	unsigned int  L;
	unsigned char C[1];
} ECCCipher;
/*  7. ECCSignature_st          ECCǩݽṹ
 *
 *  Ա                ˵
 *  r                   32B     ǩr
 *  s                   32B     ǩs
 */
typedef struct ECCSignature_st
{
	unsigned char r[ECCref_MAX_LEN];	
	unsigned char s[ECCref_MAX_LEN];	
} ECCSignature;
typedef struct SDFE_ENVELOPEDKEYBLOB
{
    unsigned int Version;
    unsigned int ulSymmAlgID;
    unsigned int ulBits;
    unsigned char cbEncryptedPrikey[64];
    ECCrefPublicKey PubKey;
    ECCCipher ECCCipherBlob;
}ENVELOPEDKEYBLOB,*PENVELOPEDKEYBLOB;
/* ///////////////////////////////////////////////////////////////////////// */
/*  ӿڶ	*/
/* ///////////////////////////////////////////////////////////////////////// */
#ifdef __cplusplus
    extern "C"{
#endif

/*  ֵ  0 -  ɹ, 0 - ʧܣش*/

char * SDF_GetAPIVersion();

/*  F1. 豸ຯ*/
/*  F1.1  
 *  ԭ  int SDF_OpenDevice        
 *    豸
 *    phDeviceHandle[out]     豸
 *  ֵ0                       ɹ
 *          0                     ʧܣش
 *  ע  phDeviceHandle ɺʼд         
 */
int SDF_OpenDevice(void **phDeviceHandle);

/*  F1.2  
 *  ԭ  int SDF_CloseDevice       
 *    ر豸ͷԴ
 *    hDeviceHandle[in]       Ѵ򿪵豸ʾ
 *  ֵ0                       ɹ
 *          0                     ʧܣش
 */
int SDF_CloseDevice(void *hDeviceHandle);

/*  F1.3 
 *  ԭ  int SDF_OpenSession       
 *    豸ĻỰ
 *    hDeviceHandle[in]       Ѵ򿪵豸
 *          phSessionHandle[out]    豸»Ự
 *  ֵ0                       ɹ
 *          0                     ʧܣش
 */
int SDF_OpenSession(void *hDeviceHandle, void **phSessionHandle);

/*  F1.4 
 *  ԭ  int SDF_CloseSession      
 *    ر豸ѽĻỰͷԴ
 *    hSessionHandle[in]      豸ѽĻỰ
 *  ֵ0                       ɹ
 *          0                     ʧܣش
 */
int SDF_CloseSession(void *hSessionHandle);

/*  F1.5  
 *  ԭ  int SDF_GetDeviceInfo     
 *    ȡ豸
 *    hSessionHandle[in]      豸ѽĻỰ
 *          pstDeviceInfo[out]      豸Ϣݼʽ豸Ϣ
 *  ֵ0                       ɹ
 *          0                     ʧܣش
 */
int SDF_GetDeviceInfo(void *hSessionHandle, 
            DEVICEINFO *pstDeviceInfo);

/*  F1.6  
 * ԭ  int SDF_GenerateRandom    
 *   
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiLength[in]            ȡ
 *         pucRandom[out]          ָ룬ڴŻȡ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_GenerateRandom(void *hSessionHandle, 
            unsigned int  uiLength, unsigned char *pucRandom);

/*  F1.7  
 * ԭ  int SDF_GetPrivateKeyAccessRight      
 *   ȡ豸ڲ洢ָ˽ԿʹȨ
 *   hSessionHandle[in]      豸ѽĻỰ
 *          uiKeyIndex[in]         豸洢˽Կֵֻ֧1
 *          pucPassword[in]        ʹ˽ԿȨޱʶ
 *          uiPwdLength[in]        ˽ԿȨޱʶ볤ȣ8ֽ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  淶漰豸洢ԿֵĵʼֵΪ1
 *         Ϊn豸ʵʴ洢nֵ
 */
int SDF_GetPrivateKeyAccessRight(void *hSessionHandle, 
            unsigned int  uiKeyIndex,
            unsigned char *pucPassword, unsigned int  uiPwdLength);

/*  F1.8  
 * ԭ  int SDF_ReleasePrivateKeyAccessRight  
 *   ͷ豸洢ָ˽ԿʹȨ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyIndex[in]          豸洢˽Կֵֻ֧1
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_ReleasePrivateKeyAccessRight(void *hSessionHandle, 
            unsigned int  uiKeyIndex);

/*  F2. Կຯ*/
/* F2.1  
 * ԭ  int SDF_ExportSignPublicKey_RSA  
 *   豸ڲ洢ָλõǩԿ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyIndex[in]          豸洢RSAǩԿֵ
 *         pucPublicKey[out]       RSAԿṹ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_ExportSignPublicKey_RSA(void *hSessionHandle, 
            unsigned int  uiKeyIndex, RSArefPublicKey *pucPublicKey);

/*  F2.2  
 * ԭ  int SDF_ExportEncPublicKey_RSA
 *   豸ڲ洢ָλõļܹԿ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyIndex[in]          豸洢RSAܹԿֵ
 *         pucPublicKey[out]       RSAԿṹ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */int SDF_ExportEncPublicKey_RSA(void *hSessionHandle, 
            unsigned int  uiKeyIndex, RSArefPublicKey *pucPublicKey);

/*  F2.3  
 * ԭ  int SDF_GenerateKeyPair_RSA
 *   豸ָͺģRSAǶԳԿԡ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyBits[in]           ָԿģ
 *         pucPublicKey[out]       RSAԿṹ
 *         pucPrivateKey[out]      RSA˽Կṹ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_GenerateKeyPair_RSA(void *hSessionHandle, 
            unsigned int  uiKeyBits,
            RSArefPublicKey *pucPublicKey, RSArefPrivateKey *pucPrivateKey);

/*  F2.4
 * ԭ  int SDF_GenerateKeyWithIPK_RSA
 *   ɻỰԿָڲRSAܹԿͬʱԿ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiIPKIndex[int]         豸ڲ洢RSAܹԿֵ
 *         uiKeyBits[int]          ָĻỰԿ, 2008-7-2
 *         pucKey[out]             ָ룬ڴŷصԿ
 *         puiKeyLength[out]       صԿĳ
 *         phKeyHandle[out]        صԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  Կʱ䷽ʽװPKCS#1 v1.5Ҫ
 */
int SDF_GenerateKeyWithIPK_RSA(void *hSessionHandle, 
            unsigned int uiIPKIndex, unsigned int uiKeyBits,
            unsigned char *pucKey, unsigned int *puiKeyLength,
            void **phKeyHandle);
/*  F2.5 
 * ԭ  int SDF_GenerateKeyWithEPK_RSA
 *   ɻỰԿⲿָԿͬʱԿ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyBits[in]           ָĻỰԿ
 *         pucPublicKey[in]        ⲿRSAԿṹ
 *         pucKey[out]             ָ룬ڴŷصԿ
 *         puiKeyLength[out]       صԿĳ
 *         phKeyHandle[out]       صԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  Կʱ䷽ʽװPKCS#1 v1.5Ҫ
 */
int SDF_GenerateKeyWithEPK_RSA(void *hSessionHandle, 
            unsigned int uiKeyBits, RSArefPublicKey *pucPublicKey,
            unsigned char *pucKey, unsigned int *puiKeyLength,
            void **phKeyHandle);

/*  F2.6
 * ԭ  int  SDF_GenerateKeyWithIPK_RSA
 *   ỰԿڲRSA˽Կܡ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiISKIndex[in]          豸ڲ洢˽ԿֵӦڼʱĹԿ
 *         pucKey[in]              ָ룬ڴԿ
 *         puiKeyLength[in]        Կĳ
 *         phKeyHandle[out]        صԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 *  ע   ䷽ʽ빫Կʱͬ
 */
int SDF_ImportKeyWithISK_RSA(void *hSessionHandle, 
            unsigned int uiISKIndex,
            unsigned char *pucKey, unsigned int *puiKeyLength,
            void **phKeyHandle);
/*  F2.7
 * ԭ  int  SDF_ExchangeDigitEnvelopeBaseOnRSA
 *   ڲܹԿܵĻỰԿתΪⲿָĹԿܣŷת
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyIndex[in]          豸洢ڲRSAԿֵ
 *         pucPublicKey[in]        ⲿRSAԿṹ
 *         pucDEInput[in]          ָ룬ڴĻỰԿ
 *         uiDELength[in]          ĻỰԿĳ
 *         pucDEOutput[out]        ָ룬ڴĻỰԿ
 *         puiDELength[out]        ĻỰԿĳ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_ExchangeDigitEnvelopeBaseOnRSA(void *hSessionHandle, 
            unsigned int  uiKeyIndex, RSArefPublicKey *pucPublicKey,
            unsigned char *pucDEInput,  unsigned int  uiDELength,
            unsigned char *pucDEOutput, unsigned int  *puiDELength);

/*  F2.8  
 * ԭ  int SDF_ExportSignPublicKey_ECC
 *   豸ڲ洢ָλõǩԿ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyIndex[in]          豸洢ECCǩԿֵ
 *         pucPublicKey[out]       ECCԿṹ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_ExportSignPublicKey_ECC(void *hSessionHandle, 
            unsigned int  uiKeyIndex, ECCrefPublicKey *pucPublicKey);

/*  F2.9  
 * ԭ  int SDF_ExportEncPublicKey_ECC
 *   豸ڲ洢ָλõļܹԿ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyIndex[in]          豸洢ECCܹԿֵ
 *         pucPublicKey[out]       ECCԿṹ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_ExportEncPublicKey_ECC(void *hSessionHandle, 
            unsigned int  uiKeyIndex, ECCrefPublicKey *pucPublicKey);

/*  F2.10  
 * ԭ  int SDF_GenerateKeyPair_ECC
 *   豸ָͺģECCǶԳԿԡ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiAlgID[in]             ָECC㷨ʶ
 *         uiKeyBits[in]           ָԿģ
 *         pucPublicKey[out]       ECCԿṹ
 *         pucPrivateKey[out]      ECC˽Կṹ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_GenerateKeyPair_ECC(void *hSessionHandle, 
            unsigned int  uiAlgID, unsigned int  uiKeyBits,
            ECCrefPublicKey *pucPublicKey, ECCrefPrivateKey *pucPrivateKey);

/*  F2.11
 * ԭ  int  SDF_GenerateKeyWithIPK_ECC
 *   ɻỰԿָڲECCܹԿͬʱԿ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiIPKIndex[in]          豸ڲ洢ECCܹԿֵ
 *         uiKeyBits[in]           ָĻỰԿ, 2008-7-2
 *         pucKey[out]             ָ룬ڴŷصԿ
 *         phKeyHandle[out]        صԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_GenerateKeyWithIPK_ECC (void *hSessionHandle, 
            unsigned int uiIPKIndex, unsigned int uiKeyBits, 
            ECCCipher *pucKey, void **phKeyHandle);

/*  F2.12
 * ԭ  int  SDF_GenerateKeyWithEPK_ECC
 *   ɻỰԿⲿָԿͬʱԿ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyBits[in]           ָĻỰԿ, 2008-7-2
 *         uiAlgID[in]             ָECC㷨ʶ
 *         pucPublicKey[in]        ⲿECCԿṹ
 *         pucKey[out]             ָ룬ڴŷصԿ
 *         phKeyHandle[out]        صԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_GenerateKeyWithEPK_ECC(void *hSessionHandle, 
            unsigned int uiKeyBits,
            unsigned int  uiAlgID, ECCrefPublicKey *pucPublicKey,
            ECCCipher *pucKey, void **phKeyHandle);

/*  F2.13
 * ԭ  int  SDF_ImportKeyWithISK_ECC
 *   ỰԿڲECC˽Կܡ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiISKIndex[in]          豸ڲ洢ECC˽ԿֵӦڼʱĹԿ
 *         pucKey[in]              ָ룬ڴԿ
 *         phKeyHandle[out]        صԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_ImportKeyWithISK_ECC(void *hSessionHandle,
            unsigned int uiISKIndex,
            ECCCipher *pucKey, void **phKeyHandle);

/*  F2.14  
 * ԭ  int SDF_GenerateAgreementDataWithECC
 *   ʹECCԿЭ㷨ΪỰԿЭ̲
 *         ͬʱָλõECCԿʱECCԿԵĹԿЭ̾
 *   hSessionHandle[in]      豸ĻỰ
 *         uiISKIndex[in]          豸ڲ洢˽Կֵ˽ԿڲԿЭ
 *         uiKeyBits[in]           Э̺ҪԿ
 *         pucSponsorID[in]        ԿЭ̵ļ()ûIDֵ
 *         uiSponsorIDLength[in]   ()ûIDĳ
 *         pucSponsorPublicKey[out]      صļ()ECCԿṹ
 *         pucSponsorTmpPublicKey[out]   صļ()ʱECCԿṹ
 *         phAgreementHandle[out]        صЭ̾ЭԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ΪЭ̻ỰԿЭ̵ķӦȵñ
 *         ھӦУЭ˫ûͳһID,ԽID趨Ϊ,
 *         Լ£ûݱʶIDĳΪ16ֽڣĬֵ
 *         Ϊ0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 
 *                     0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38
 *         һúɷȵá
 */
int SDF_GenerateAgreementDataWithECC (void *hSessionHandle, 
            unsigned int uiISKIndex,     unsigned int uiKeyBits,
            unsigned char *pucSponsorID, unsigned int uiSponsorIDLength,
            ECCrefPublicKey  *pucSponsorPublicKey,
            ECCrefPublicKey  *pucSponsorTmpPublicKey,
            void **phAgreementHandle);

/*  F2.15 
 * ԭ  int SDF_GenerateAgreementDataAndKeyWithECC
 *   ʹECCԿЭ㷨Э̲ỰԿ
 *         ͬʱزЭ̲ͺԿ
 *    hSessionHandle[in]      豸ѽĻỰ
 *         uiISKIndex[in]          豸ڲ洢˽Կֵ
 *                                 ˽ԿڲԿЭ
 *         uiKeyBits[in]           Э̺ҪԿ
 *         pucResponseID[in]       ӦIDֵ
 *         uiResponseIDLength[in]  ӦID
 *         pucSponsorID[in]        IDֵ
 *         uiSponsorIDLength[in]   ID
 *         pucSponsorPublicKey[in] ⲿķECCԿṹ
 *         pucSponsorTmpPublicKey[in]   ⲿķʱECCԿṹ
 *         pucResponsePublicKey[out]    صӦECCԿṹ
 *         pucResponseTmpPublicKey[out] صӦʱECCԿṹ
 *         phKeyHandle[out]             صԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 *  ע Ӧá
 *         ھӦУЭ˫ûͳһID,ԽID趨Ϊ,
 *         Լ£ûݱʶIDĳΪ16ֽڣĬֵ
 *         Ϊ0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 
 *                     0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38
 *         ڶúڷ𷽵úSDF_ImportKeyWithISK_ECCá
 */
int SDF_GenerateAgreementDataAndKeyWithECC(void *hSessionHandle, 
            unsigned int uiISKIndex,      unsigned int uiKeyBits,
            unsigned char *pucResponseID, unsigned int uiResponseIDLength,
            unsigned char *pucSponsorID,  unsigned int uiSponsorIDLength,
            ECCrefPublicKey *pucSponsorPublicKey,
            ECCrefPublicKey *pucSponsorTmpPublicKey,
            ECCrefPublicKey  *pucResponsePublicKey,
            ECCrefPublicKey  *pucResponseTmpPublicKey,
            void **phKeyHandle);

/*  F2.16  
 * ԭ  int SDF_GenerateKeyWithECC
 *   ʹЭ̾ӦЭݼỰԿͬʱԿ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         pucResponseID[in]       ⲿĶԷ(Ӧ)ûIDֵ
 *         uiResponseIDLength[in]  ⲿĶԷ(Ӧ)ûID
 *         pucResponsePublicKey[in]ⲿĶԷ(Ӧ)ECCԿṹ
 *         pucResponseTmpPublicKey[in]   ⲿĶԷ(Ӧ)ʱECCԿṹ
 *         hAgreementHandle[in]          Э̾ڼЭԿ
 *         phKeyHandle[out]              صԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 *  ע   Э̵ķ𷽻ӦЭ̲ñỰԿ
 *         ھӦУЭ˫ûͳһID,ԽID趨Ϊ,
 *         Լ£ûݱʶIDĳΪ16ֽڣĬֵ
 *         Ϊ0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 
 *                     0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38
 *         úӦúSDF_GenerateAgreementDataAndKeyWithECCִС
 */
int SDF_GenerateKeyWithECC(void *hSessionHandle, 
            unsigned char *pucResponseID, unsigned int uiResponseIDLength,
            ECCrefPublicKey *pucResponsePublicKey,
            ECCrefPublicKey *pucResponseTmpPublicKey,
            void *hAgreementHandle, void **phKeyHandle);

/*  F2.17
 * ԭ  int  SDF_ExchangeDigitEnvelopeBaseOnECC
 *   ڲܹԿܵĻỰԿתΪⲿָĹԿܣŷת
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyIndex[in]          豸洢ECCԿֵ
 *         uiAlgID[in]             ⲿECCԿ㷨ʶ
 *         pucPublicKey[in]        ⲿECCԿṹ
 *         pucEncDataIn[in]        ָ룬ڴĻỰԿ
 *         pucEncDataOut[out]      ָ룬ڴĻỰԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_ExchangeDigitEnvelopeBaseOnECC(void *hSessionHandle, 
            unsigned int  uiKeyIndex, unsigned int  uiAlgID,
            ECCrefPublicKey *pucPublicKey,
            ECCCipher *pucEncDataIn, ECCCipher *pucEncDataOut);

/*  F2.18
 * ԭ  int  SDF_GenerateKeyWithKEK
 *   ɻỰԿԿԿͬʱԿ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyBits[in]           ָĻỰԿ
 *         uiAlgID[in]             ָԳƼ㷨ʶ
 *         uiKEKIndex[in]          豸ڲ洢ԿԿֵ
 *         pucKey[out]             ָ룬ڴŷصԿ
 *         puiKeyLength[out]       صԿĳ
 *         phKeyHandle[out]        صԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  : ģʽĬʹECBģʽ
 */
int SDF_GenerateKeyWithKEK (void *hSessionHandle, 
            unsigned int uiKeyBits,
            unsigned int  uiAlgID, unsigned int uiKEKIndex, 
            unsigned char *pucKey, unsigned int *puiKeyLength, 
            void **phKeyHandle);

/*  F2.19
 * ԭ  int SDF_ImportKeyWithKEK
 *   ỰԿԿԿܣͬʱػỰԿ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiAlgID[in]             ָԳƼ㷨ʶ
 *         uiKEKIndex[in]          豸ڲ洢ԿԿֵ
 *         pucKey[in]              ָ룬ڴԿ
 *         puiKeyLength[in]        Կĳ
 *         phKeyHandle[out]        صԿ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 *  ע   ģʽĬʹECBģʽ
 */
int SDF_ImportKeyWithKEK(void *hSessionHandle, 
            unsigned int  uiAlgID, unsigned int uiKEKIndex, 
            unsigned char *pucKey, unsigned int puiKeyLength, 
            void **phKeyHandle);

int SDF_ImportKey(
	void			*hSessionHandle, 
	unsigned char	*pucKey, 
	unsigned int	uiKeyLength,
	void			**phKeyHandle
);

/*  F2.20
 * ԭ  int SDF_DestroyKey
 *   ٻỰԿͷΪԿڴԴ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         hKeyHandle[in]          Կ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ڶԳ㷨ɺӦñٻỰԿ
 */
int SDF_DestroyKey(void *hSessionHandle, 
            void *hKeyHandle);

/*  F3. ǶԳ㷨ຯ*/
/*  F3.1 
 * ԭ  int SDF_ExternalPublicKeyOperation_RSA
 *   ָʹⲿԿݽ㡣
 *   hSessionHandle[in]      豸ѽĻỰ
 *         pucPublicKey[in]        ָⲿRSAԿṹ
 *         pucDataInput[in]        ָ룬ڴ
 *         uiInputLength[in]       ݳ
 *         pucDataOutput[out]      ָ룬ڴ
 *         puiOutputLength[out]    ݳ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 *  ע ݸʽӦòװ
 */
int SDF_ExternalPublicKeyOperation_RSA(void *hSessionHandle, 
            RSArefPublicKey *pucPublicKey,
            unsigned char *pucDataInput,  unsigned int  uiInputLength,
            unsigned char *pucDataOutput, unsigned int  *puiOutputLength);

/*  F3.2  
 * ԭ  int SDF_InternalPublicKeyOperation_RSA
 *   ʹڲָĹԿݽ㡣
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyIndex[in]          豸ڲ洢ǩԿֵ
 *         pucDataInput[in]        ָ룬ڴ
 *         uiInputLength[in]       ݳ
 *         pucDataOutput[out]      ָ룬ڴ
 *         puiOutputLength[out]    ݳ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ΧڲǩԿԡ
 */
int SDF_InternalPublicKeyOperation_RSA(void *hSessionHandle,
            unsigned int  uiKeyIndex,
            unsigned char *pucDataInput,  unsigned int  uiInputLength,
            unsigned char *pucDataOutput, unsigned int  *puiOutputLength);

/*  F3.3
 * ԭ  int  SDF_InternalPrivateKeyOperation_RSA
 *   ʹڲָ˽Կݽ㡣
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiKeyIndex[in]          豸ڲ洢ǩ˽Կֵ
 *         pucDataInput[in]        ָ룬ڴⲿ
 *         uiInputLength[in]       ݳ
 *         pucDataOutput[out]      ָ룬ڴ
 *         puiOutputLength[out]    ݳ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ΧڲǩԿԣݸʽӦòװ
 */
int SDF_InternalPrivateKeyOperation_RSA(void *hSessionHandle,
            unsigned int  uiKeyIndex,
            unsigned char *pucDataInput,  unsigned int  uiInputLength,
            unsigned char *pucDataOutput, unsigned int  *puiOutputLength);

/*  F3.4
 * ԭ  int  SDF_ExternalVerify_ECC
 *   ʹⲿECCԿECCǩֵ֤㡣
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiAlgID[in]             㷨ʶָʹõECC㷨
 *         pucPublicKey[in]        ⲿECCԿṹ
 *         pucData[in]             ָ룬ڴⲿ
 *         uiDataLength[in]        ݳ
 *         pucSignature[in]        ָ룬ڴǩֵ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ΪǩݵӴֵʹSM2㷨ʱΪǩݾSM2ǩԤĽ
 *         Ԥ̼GM/T 0009
 */
int SDF_ExternalVerify_ECC(void *hSessionHandle,
            unsigned int uiAlgID, ECCrefPublicKey *pucPublicKey,
            unsigned char *pucDataInput, unsigned int  uiInputLength,
            ECCSignature *pucSignature);
int SDF_ExternalSign_ECC(
	void				*hSessionHandle,
	unsigned int		uiAlgID, 
	ECCrefPrivateKey	*pucPrivateKey,
	unsigned char		*pucData, 
	unsigned int		uiDataLength,
	ECCSignature		*pucSignature
	);

int 
SDF_InternalEncrypt_ECC(
	void			*hSessionHandle,
	unsigned int	uiIPKIndex,
	unsigned char	*pucData, 
	unsigned int	uiDataLength,
	ECCCipher		*pucEncData
	);

int 
SDF_InternalDecrypt_ECC(
	void			*hSessionHandle,
	unsigned int	uiISKIndex,
	ECCCipher		*pucEncData,
	unsigned char	*pucData, 
	unsigned int	*puiDataLength
	);

/*  F3.5 
 * ԭ  int SDF_InternalSign_ECC
 *   ʹڲECC˽Կݽǩ㡣
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiISKIndex[in]          豸ڲ洢ECCǩ˽Կֵ
 *         pucData[in]             ָ룬ڴⲿ
 *         uiDataLength[in]        ݳ
 *         pucSignature[out]       ָ룬ڴǩֵ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ΪǩݵӴֵʹSM2㷨ʱΪǩݾSM2ǩԤĽ
 *         Ԥ̼GM/T 0009
 */
int SDF_InternalSign_ECC(void *hSessionHandle,
            unsigned int  uiISKIndex,
            unsigned char *pucData, unsigned int  uiDataLength,
            ECCSignature *pucSignature);

/*  F3.6
 * ԭ  int  SDF_InternalVerify_ECC
 *   ʹڲECCԿECCǩֵ֤㡣
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiISKIndex[in]          豸ڲ洢ECCǩԿֵ
 *         pucData[in]             ָ룬ڴⲿ
 *         uiDataLength[in]        ݳ
 *         pucSignature[in]        ָ룬ڴǩֵ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ΪǩݵӴֵʹSM2㷨ʱΪǩݾSM2ǩԤĽ
 *         Ԥ̼GM/T 0009
 */
int SDF_InternalVerify_ECC(void *hSessionHandle,
            unsigned int  uiIPKIndex,
            unsigned char *pucData, unsigned int  uiDataLength,
            ECCSignature *pucSignature);

/*  F3.7
 * ԭ  int  SDF_ExternalEncrypt_ECC
 *   ʹⲿECCԿݽм㡣
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiAlgID[in]             ָʹõECC㷨ʶ
 *         pucPublicKey[in]        ⲿָECCԿṹ
 *         pucData[in]             ָ룬ڴⲿ
 *         uiDataLength[in]        ݳ
 *         pucEncData[out]         ָ룬ڴ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ݳuiDataLengthECCref_MAX_LEN
 */
int SDF_ExternalEncrypt_ECC(void *hSessionHandle,
            unsigned int uiAlgID, ECCrefPublicKey *pucPublicKey,
            unsigned char *pucData, unsigned int  uiDataLength,
            ECCCipher *pucEncData);

int SDF_ExternalDecrypt_ECC(
	void				*hSessionHandle,
    unsigned int		uiAlgID, 
	ECCrefPrivateKey	*pucPrivateKey,
    ECCCipher			*pucEncData,
    unsigned char		*pucData, 
	unsigned int		*puiDataLength
	);

/*  F4. Գ㷨ຯ*/
/*  F4.1 
 * ԭ  int SDF_Encrypt
 *   ʹָԿIVݽжԳƼ㡣
 *   hSessionHandle[in]      豸ѽĻỰ
 *         hKeyHandle[in]          ָԿ
 *         uiAlgID[in]             㷨ʶָԳƼ㷨
 *         pucIV[in|out]           ָ룬ڴͷصIV
 *         pucData[in]             ָ룬ڴ
 *         uiDataLength[in]        ĳ
 *         pucEncData[out]         ָ룬ڴ
 *         puiEncDataLength[out]   ĳ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ˺ݽ䴦ݱָ㷨鳤ȵ
 */
int SDF_Encrypt(void *hSessionHandle,
            void *hKeyHandle,
            unsigned int uiAlgID,      unsigned char *pucIV,
            unsigned char *pucData,    unsigned int uiDataLength,
            unsigned char *pucEncData, unsigned int  *puiEncDataLength);

/*  F4.2 
 * ԭ  int SDF_Decrypt
 *   ʹָԿIVݽжԳƽ㡣
 *   hSessionHandle[in]      豸ѽĻỰ
 *         hKeyHandle[in]          ָԿ
 *         uiAlgID[in]             ָԳƼ㷨ʶ
 *         pucIV[in|out]           ָ룬ڴͷصIV
 *         pucEncData[int]         ָ룬ڴ
 *         puiEncDataLength[in]    ĳ
 *         pucData[out]            ָ룬ڴ
 *         puiDataLength[out]      ĳ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ˺ݽ䴦ݱָ㷨鳤ȵ
 */
int SDF_Decrypt(void *hSessionHandle,
            void *hKeyHandle,
            unsigned int uiAlgID,      unsigned char *pucIV,
            unsigned char *pucEncData, unsigned int  uiEncDataLength,
            unsigned char *pucData,    unsigned int *puiDataLength);

/*  F4.3
 * ԭ  int  SDF_CalculateMAC
 *   ʹָԿIVݽMAC㡣
 *   hSessionHandle[in]      豸ѽĻỰ
 *         hKeyHandle[in]          ָԿ
 *         uiAlgID[in]             㷨ʶָMAC㷨
 *         pucIV[in|out]           ָ룬ڴͷصIV
 *         pucData[in]             ָ룬ڴ
 *         uiDataLength[in]        ĳ
 *         pucMAC[out]             ָ룬ڴMACֵ
 *         puiMACLength[out]       MACֵ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ˺ݽзְMACIVMACֵ
 */
int SDF_CalculateMAC(void *hSessionHandle,
            void *hKeyHandle,
            unsigned int uiAlgID,   unsigned char *pucIV,
            unsigned char *pucData, unsigned int uiDataLength,
            unsigned char *pucMAC,  unsigned int  *puiMACLength);

/*  F5. Ӵຯ*/
/*  F5.1 
 * ԭ  int SDF_HashInit
 *   ʽӴһ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         uiAlgID[in]             ָӴ㷨ʶ
 *         pucPublicKey[in]        ǩߵECCԿECCǩӴֵʱЧ
 *         pucID[in]               ǩߵIDֵECCǩӴֵʱЧ
 *         uiIDLength[in]          ǩߵID
 * ֵ0                       ɹ
 *         0                     ʧܣش
 * ע  ھӦУЭ˫ûͳһID,ԽID趨Ϊ,
 *         Լ£ûݱʶIDĳΪ16ֽڣĬֵ
 *         Ϊ0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 
 *                     0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38
 */
int SDF_HashInit(void *hSessionHandle,
            unsigned int uiAlgID, 
            ECCrefPublicKey *pucPublicKey, 
            unsigned char *pucID, unsigned int uiIDLength);

/*  F5.2 
 * ԭ  int SDF_HashUpdate
 *   ʽӴڶĽӴ㡣
 *
 *   hSessionHandle[in]      豸ѽĻỰ
 *         pucData[in]             ָ룬ڴ
 *         uiDataLength[in]        ĳ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_HashUpdate(void *hSessionHandle,
            unsigned char *pucData, unsigned int  uiDataLength);

/*  F5.3
 * ԭ  int  SDF_HashFinal
 *   ʽӴӴӴݲмݡ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         pucHash[out]            ָ룬ڴӴ
 *         puiHashLength[out]      صӴݳ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_HashFinal(void *hSessionHandle,
            unsigned char *pucHash, unsigned int  *puiHashLength);

/*  F6. ûļຯ*/
/*  F6.1
 * ԭ  int  SDF_CreateFile
 *   豸ڲڴ洢ûݵļ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         pucFileName[in]         ָ룬ڴļ󳤶128ֽ
 *         uiNameLen[in]           ļ
 *         uiFileSize[in]          ļռ洢ռĳ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_CreateFile(void *hSessionHandle,
            unsigned char *pucFileName, unsigned int uiNameLen, 
            unsigned int uiFileSize);

/*  F6.2 
 * ԭ  int SDF_ReadFile
 *   ȡ豸ڲ洢ûݵļݡ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         pucFileName[in]         ָ룬ڴļ󳤶128ֽ
 *         uiNameLen[in]           ļ
 *         uiOffset[in]            ȡļƫƵַ0ʼ
 *         puiFileLength[in|out]   ʱָȡļݵĳȣ
 *                                 ʱʵʶȡļݵĳ
 *         pucBuffer[out]          ָ룬ڴŶȡļ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_ReadFile(void *hSessionHandle,
            unsigned char *pucFileName, unsigned int uiNameLen,
            unsigned int uiOffset, unsigned int *puiFileLength,
            unsigned char *pucBuffer);

/*  F6.3 
 * ԭ  int SDF_WriteFile
 *   豸ڲ洢ûݵļдݡ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         pucFileName[in]         ָ룬ڴļ󳤶128ֽ
 *         uiNameLen[in]           ļ
 *         uiOffset[in]            дļƫƵַ0ʼ
 *         uiFileLength[in]        ָдļݵĳ
 *         pucBuffer[in]           ָ룬ڴдļ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_WriteFile(void *hSessionHandle,
            unsigned char *pucFileName, unsigned int uiNameLen,
            unsigned int uiOffset, unsigned int uiFileLength,
            unsigned char *pucBuffer);

/*  F6.4
 * ԭ  int  SDF_DeleteFile
 *   ɾָļ豸ڲ洢ûݵļ
 *   hSessionHandle[in]      豸ѽĻỰ
 *         pucFileName[in]         ָ룬ڴļ󳤶128ֽ
 *         uiNameLen[in]           ļ
 * ֵ0                       ɹ
 *         0                     ʧܣش
 */
int SDF_DeleteFile(void *hSessionHandle,
            unsigned char *pucFileName, unsigned int uiNameLen);

int SDF_ImportLMK(
	void 			*hDeviceHandle,
	unsigned char	*pbyAdminPin,
	unsigned int	uiPinLen,
	unsigned char	*pbyLMKData,
	unsigned int	uiLMKLen);

int SDF_ImportDevKey(
	void 			*hDeviceHandle,
	unsigned int	uiKeyType,
	unsigned int	uiAlgID,
	unsigned char	*iv,
	unsigned char	*pbyAdminPin,
	unsigned int	uiPinLen,
	unsigned char	*pbyKeyData,
	unsigned int	uiKeyLen);

int SDF_ImportSymKey(
	void 			*hDeviceHandle,
	unsigned int	uiKeyIndex,
	unsigned int	uiAlgID,
	unsigned char	*iv,
	unsigned char	*pbyAdminPin,
	unsigned int	uiPinLen,
	unsigned char	*pbyKeyData,
	unsigned int	uiKeyLen);

int SDF_ImportAsymKey(
	void 			*hDeviceHandle,
	unsigned int	uiKeyType,
	unsigned int	uiKeyIndex,
	unsigned int	uiAlgID,
	unsigned char	*iv,
	unsigned char	*pbyAdminPin,
	unsigned int	uiPinLen,
	unsigned char	*pbyKeyData,
	unsigned int	uiKeyLen);
int
SDFE_GenUserCfgKeyPair(
	void				*hSessionHandle,
	unsigned int		    uiKeypairIndex,
	unsigned char	*		pbyAccess,
	unsigned int			 uiAccesslen) ;
/*
int
SDF_ImportUserCfgKeyPair(
	void				*hSessionHandle,       
	unsigned int             uiCfgIndex,
	ECCrefPublicKey  *pucPublicKey, 
	ECCrefPrivateKey *pucPrivateKey,
	unsigned char	*			pbyAccess,
	unsigned int			 uiAccesslen)  ;
*/
int 
SDFE_EnableUserCfgPubKey(
	void			*hSessionHandle,	// In
	unsigned int	uiKeyIndex
	);
int 
SDFE_DisableUserCfgPubKey(
	void			*hSessionHandle,	// In
	unsigned int	uiKeyIndex			// In
	);
int 
SDFE_ImportKeyWithISK_ECCSIGN(
	void			*hSessionHandle,
	unsigned int	uiISKIndex,
	ECCCipher		*pucKey,
	void			**phKeyHandle
	);
int
SDFE_ImportUserCfgKeyPair(
	void				*hSessionHandle,       
	unsigned int             uiCfgIndex,
   ENVELOPEDKEYBLOB *    keyBlob,
	unsigned char	*			pbyAccess,
	unsigned int			 uiAccesslen);

#ifdef __cplusplus
    }
#endif
#endif 
